#include "dma_image.h"

pci_tx_api  PCI_TX_storage;
pci_tx_api *PCI_TX=&PCI_TX_storage;

pci_rx_api  PCI_RX_storage;
pci_rx_api *PCI_RX=&PCI_RX_storage;

fec_tx_bd_api  FEC_TX_storage;
fec_tx_bd_api *FEC_TX=&FEC_TX_storage;

fec_rx_bd_api  FEC_RX_storage;
fec_rx_bd_api *FEC_RX=&FEC_RX_storage;

gen_dp_api  LPC_storage;
gen_dp_api *LPC=&LPC_storage;

gen_dp_bd_api  ATA_storage;
gen_dp_bd_api *ATA=&ATA_storage;

crc16_dp_api  CRC16_DP_0_storage;
crc16_dp_api *CRC16_DP_0=&CRC16_DP_0_storage;

crc16_dp_api  CRC16_DP_1_storage;
crc16_dp_api *CRC16_DP_1=&CRC16_DP_1_storage;

gen_dp_api  GEN_DP_0_storage;
gen_dp_api *GEN_DP_0=&GEN_DP_0_storage;

gen_dp_api  GEN_DP_1_storage;
gen_dp_api *GEN_DP_1=&GEN_DP_1_storage;

gen_dp_api  GEN_DP_2_storage;
gen_dp_api *GEN_DP_2=&GEN_DP_2_storage;

gen_dp_api  GEN_DP_3_storage;
gen_dp_api *GEN_DP_3=&GEN_DP_3_storage;

gen_tx_bd_api  GEN_TX_BD_storage;
gen_tx_bd_api *GEN_TX_BD=&GEN_TX_BD_storage;

gen_rx_bd_api  GEN_RX_BD_storage;
gen_rx_bd_api *GEN_RX_BD=&GEN_RX_BD_storage;

gen_dp_bd_api  GEN_DP_BD_0_storage;
gen_dp_bd_api *GEN_DP_BD_0=&GEN_DP_BD_0_storage;

gen_dp_bd_api  GEN_DP_BD_1_storage;
gen_dp_bd_api *GEN_DP_BD_1=&GEN_DP_BD_1_storage;



void init_dma_image(uint8 *taskBar) {
   PCI_TX->TaskNum                     = 0;
   PCI_TX->PtrStartTDT                 = (volatile uint32 *)(taskBar + 0x0000UL);
   PCI_TX->PtrEndTDT                   = (volatile uint32 *)(taskBar + 0x0004UL);
   PCI_TX->PtrVarTab                   = (volatile uint32 *)(taskBar + 0x0008UL);
   PCI_TX->PtrFDT                      = (volatile uint32 *)(taskBar + 0x000cUL);
   PCI_TX->PtrCSave                    = (volatile uint32 *)(taskBar + 0x0018UL);
   PCI_TX->TaskPragma                  = (volatile uint8  *)&(PCI_TX->PtrFDT)+3;
   PCI_TX->NumDRD                      = 7;
   PCI_TX->DRD[0]                      = (volatile uint32 *)(*(PCI_TX->PtrStartTDT) + 0x0008UL);
   PCI_TX->DRD[1]                      = (volatile uint32 *)(*(PCI_TX->PtrStartTDT) + 0x0010UL);
   PCI_TX->DRD[2]                      = (volatile uint32 *)(*(PCI_TX->PtrStartTDT) + 0x0014UL);
   PCI_TX->DRD[3]                      = (volatile uint32 *)(*(PCI_TX->PtrStartTDT) + 0x001cUL);
   PCI_TX->DRD[4]                      = (volatile uint32 *)(*(PCI_TX->PtrStartTDT) + 0x0020UL);
   PCI_TX->DRD[5]                      = (volatile uint32 *)(*(PCI_TX->PtrStartTDT) + 0x0024UL);
   PCI_TX->DRD[6]                      = (volatile uint32 *)(*(PCI_TX->PtrStartTDT) + 0x002cUL);
   PCI_TX->NumVar                      = 12;
   PCI_TX->var                         = (volatile uint32 *)(*(PCI_TX->PtrVarTab));
   PCI_TX->NumInc                      = 5;
   PCI_TX->inc                         = (volatile uint32 *)(*(PCI_TX->PtrVarTab) + (4*24));
   PCI_TX->AddrDstFIFO                 = &(PCI_TX->var[0]);
   PCI_TX->IncrBytes                   = (volatile sint16 *)&(PCI_TX->inc[0])+1;
   PCI_TX->AddrPktSizeReg              = &(PCI_TX->var[1]);
   PCI_TX->IncrSrc                     = (volatile sint16 *)&(PCI_TX->inc[1])+1;
   PCI_TX->AddrSCStatusReg             = &(PCI_TX->var[2]);
   PCI_TX->Bytes                       = &(PCI_TX->var[3]);
   PCI_TX->IterExtra                   = &(PCI_TX->var[4]);
   PCI_TX->StartAddrSrc                = &(PCI_TX->var[7]);

   PCI_RX->TaskNum                     = 1;
   PCI_RX->PtrStartTDT                 = (volatile uint32 *)(taskBar + 0x0020UL);
   PCI_RX->PtrEndTDT                   = (volatile uint32 *)(taskBar + 0x0024UL);
   PCI_RX->PtrVarTab                   = (volatile uint32 *)(taskBar + 0x0028UL);
   PCI_RX->PtrFDT                      = (volatile uint32 *)(taskBar + 0x002cUL);
   PCI_RX->PtrCSave                    = (volatile uint32 *)(taskBar + 0x0038UL);
   PCI_RX->TaskPragma                  = (volatile uint8  *)&(PCI_RX->PtrFDT)+3;
   PCI_RX->NumDRD                      = 5;
   PCI_RX->DRD[0]                      = (volatile uint32 *)(*(PCI_RX->PtrStartTDT) + 0x0008UL);
   PCI_RX->DRD[1]                      = (volatile uint32 *)(*(PCI_RX->PtrStartTDT) + 0x0010UL);
   PCI_RX->DRD[2]                      = (volatile uint32 *)(*(PCI_RX->PtrStartTDT) + 0x0014UL);
   PCI_RX->DRD[3]                      = (volatile uint32 *)(*(PCI_RX->PtrStartTDT) + 0x0018UL);
   PCI_RX->DRD[4]                      = (volatile uint32 *)(*(PCI_RX->PtrStartTDT) + 0x0020UL);
   PCI_RX->NumVar                      = 9;
   PCI_RX->var                         = (volatile uint32 *)(*(PCI_RX->PtrVarTab));
   PCI_RX->NumInc                      = 4;
   PCI_RX->inc                         = (volatile uint32 *)(*(PCI_RX->PtrVarTab) + (4*24));
   PCI_RX->AddrPktSizeReg              = &(PCI_RX->var[0]);
   PCI_RX->IncrBytes                   = (volatile sint16 *)&(PCI_RX->inc[0])+1;
   PCI_RX->AddrSrcFIFO                 = &(PCI_RX->var[1]);
   PCI_RX->IncrDst                     = (volatile sint16 *)&(PCI_RX->inc[1])+1;
   PCI_RX->Bytes                       = &(PCI_RX->var[2]);
   PCI_RX->IterExtra                   = &(PCI_RX->var[3]);
   PCI_RX->StartAddrDst                = &(PCI_RX->var[6]);

   FEC_TX->TaskNum                     = 2;
   FEC_TX->PtrStartTDT                 = (volatile uint32 *)(taskBar + 0x0040UL);
   FEC_TX->PtrEndTDT                   = (volatile uint32 *)(taskBar + 0x0044UL);
   FEC_TX->PtrVarTab                   = (volatile uint32 *)(taskBar + 0x0048UL);
   FEC_TX->PtrFDT                      = (volatile uint32 *)(taskBar + 0x004cUL);
   FEC_TX->PtrCSave                    = (volatile uint32 *)(taskBar + 0x0058UL);
   FEC_TX->TaskPragma                  = (volatile uint8  *)&(FEC_TX->PtrFDT)+3;
   FEC_TX->NumDRD                      = 11;
   FEC_TX->DRD[0]                      = (volatile uint32 *)(*(FEC_TX->PtrStartTDT) + 0x0004UL);
   FEC_TX->DRD[1]                      = (volatile uint32 *)(*(FEC_TX->PtrStartTDT) + 0x0008UL);
   FEC_TX->DRD[2]                      = (volatile uint32 *)(*(FEC_TX->PtrStartTDT) + 0x0014UL);
   FEC_TX->DRD[3]                      = (volatile uint32 *)(*(FEC_TX->PtrStartTDT) + 0x0018UL);
   FEC_TX->DRD[4]                      = (volatile uint32 *)(*(FEC_TX->PtrStartTDT) + 0x001cUL);
   FEC_TX->DRD[5]                      = (volatile uint32 *)(*(FEC_TX->PtrStartTDT) + 0x0020UL);
   FEC_TX->DRD[6]                      = (volatile uint32 *)(*(FEC_TX->PtrStartTDT) + 0x0024UL);
   FEC_TX->DRD[7]                      = (volatile uint32 *)(*(FEC_TX->PtrStartTDT) + 0x0028UL);
   FEC_TX->DRD[8]                      = (volatile uint32 *)(*(FEC_TX->PtrStartTDT) + 0x0034UL);
   FEC_TX->DRD[9]                      = (volatile uint32 *)(*(FEC_TX->PtrStartTDT) + 0x003cUL);
   FEC_TX->DRD[10]                     = (volatile uint32 *)(*(FEC_TX->PtrStartTDT) + 0x0040UL);
   FEC_TX->NumVar                      = 13;
   FEC_TX->var                         = (volatile uint32 *)(*(FEC_TX->PtrVarTab));
   FEC_TX->NumInc                      = 6;
   FEC_TX->inc                         = (volatile uint32 *)(*(FEC_TX->PtrVarTab) + (4*24));
   FEC_TX->AddrDRD                     = &(FEC_TX->var[0]);
   FEC_TX->IncrBytes                   = (volatile sint16 *)&(FEC_TX->inc[0])+1;
   FEC_TX->AddrDstFIFO                 = &(FEC_TX->var[1]);
   FEC_TX->IncrSrc                     = (volatile sint16 *)&(FEC_TX->inc[1])+1;
   FEC_TX->BDTableBase                 = &(FEC_TX->var[2]);
   FEC_TX->IncrSrcMA                   = (volatile sint16 *)&(FEC_TX->inc[2])+1;
   FEC_TX->BDTableLast                 = &(FEC_TX->var[3]);
   FEC_TX->Bytes                       = &(FEC_TX->var[4]);

   FEC_RX->TaskNum                     = 3;
   FEC_RX->PtrStartTDT                 = (volatile uint32 *)(taskBar + 0x0060UL);
   FEC_RX->PtrEndTDT                   = (volatile uint32 *)(taskBar + 0x0064UL);
   FEC_RX->PtrVarTab                   = (volatile uint32 *)(taskBar + 0x0068UL);
   FEC_RX->PtrFDT                      = (volatile uint32 *)(taskBar + 0x006cUL);
   FEC_RX->PtrCSave                    = (volatile uint32 *)(taskBar + 0x0078UL);
   FEC_RX->TaskPragma                  = (volatile uint8  *)&(FEC_RX->PtrFDT)+3;
   FEC_RX->NumDRD                      = 3;
   FEC_RX->DRD[0]                      = (volatile uint32 *)(*(FEC_RX->PtrStartTDT) + 0x0008UL);
   FEC_RX->DRD[1]                      = (volatile uint32 *)(*(FEC_RX->PtrStartTDT) + 0x0014UL);
   FEC_RX->DRD[2]                      = (volatile uint32 *)(*(FEC_RX->PtrStartTDT) + 0x001cUL);
   FEC_RX->NumVar                      = 8;
   FEC_RX->var                         = (volatile uint32 *)(*(FEC_RX->PtrVarTab));
   FEC_RX->NumInc                      = 5;
   FEC_RX->inc                         = (volatile uint32 *)(*(FEC_RX->PtrVarTab) + (4*24));
   FEC_RX->AddrSrcFIFO                 = &(FEC_RX->var[0]);
   FEC_RX->IncrBytes                   = (volatile sint16 *)&(FEC_RX->inc[0])+1;
   FEC_RX->BDTableBase                 = &(FEC_RX->var[1]);
   FEC_RX->IncrDst                     = (volatile sint16 *)&(FEC_RX->inc[1])+1;
   FEC_RX->BDTableLast                 = &(FEC_RX->var[2]);
   FEC_RX->Bytes                       = &(FEC_RX->var[3]);

   LPC->TaskNum                        = 4;
   LPC->PtrStartTDT                    = (volatile uint32 *)(taskBar + 0x0080UL);
   LPC->PtrEndTDT                      = (volatile uint32 *)(taskBar + 0x0084UL);
   LPC->PtrVarTab                      = (volatile uint32 *)(taskBar + 0x0088UL);
   LPC->PtrFDT                         = (volatile uint32 *)(taskBar + 0x008cUL);
   LPC->PtrCSave                       = (volatile uint32 *)(taskBar + 0x0098UL);
   LPC->TaskPragma                     = (volatile uint8  *)&(LPC->PtrFDT)+3;
   LPC->NumDRD                         = 4;
   LPC->DRD[0]                         = (volatile uint32 *)(*(LPC->PtrStartTDT) + 0x000cUL);
   LPC->DRD[1]                         = (volatile uint32 *)(*(LPC->PtrStartTDT) + 0x0018UL);
   LPC->DRD[2]                         = (volatile uint32 *)(*(LPC->PtrStartTDT) + 0x0024UL);
   LPC->DRD[3]                         = (volatile uint32 *)(*(LPC->PtrStartTDT) + 0x0028UL);
   LPC->NumVar                         = 9;
   LPC->var                            = (volatile uint32 *)(*(LPC->PtrVarTab));
   LPC->NumInc                         = 7;
   LPC->inc                            = (volatile uint32 *)(*(LPC->PtrVarTab) + (4*24));
   LPC->Bytes                          = &(LPC->var[0]);
   LPC->IncrBytes                      = (volatile sint16 *)&(LPC->inc[0])+1;
   LPC->IterExtra                      = &(LPC->var[1]);
   LPC->IncrDst                        = (volatile sint16 *)&(LPC->inc[1])+1;
   LPC->IncrDstMA                      = (volatile sint16 *)&(LPC->inc[2])+1;
   LPC->IncrSrc                        = (volatile sint16 *)&(LPC->inc[3])+1;
   LPC->StartAddrDst                   = &(LPC->var[4]);
   LPC->IncrSrcMA                      = (volatile sint16 *)&(LPC->inc[4])+1;
   LPC->StartAddrSrc                   = &(LPC->var[5]);

   ATA->TaskNum                        = 5;
   ATA->PtrStartTDT                    = (volatile uint32 *)(taskBar + 0x00a0UL);
   ATA->PtrEndTDT                      = (volatile uint32 *)(taskBar + 0x00a4UL);
   ATA->PtrVarTab                      = (volatile uint32 *)(taskBar + 0x00a8UL);
   ATA->PtrFDT                         = (volatile uint32 *)(taskBar + 0x00acUL);
   ATA->PtrCSave                       = (volatile uint32 *)(taskBar + 0x00b8UL);
   ATA->TaskPragma                     = (volatile uint8  *)&(ATA->PtrFDT)+3;
   ATA->NumDRD                         = 3;
   ATA->DRD[0]                         = (volatile uint32 *)(*(ATA->PtrStartTDT) + 0x0008UL);
   ATA->DRD[1]                         = (volatile uint32 *)(*(ATA->PtrStartTDT) + 0x0018UL);
   ATA->DRD[2]                         = (volatile uint32 *)(*(ATA->PtrStartTDT) + 0x001cUL);
   ATA->NumVar                         = 7;
   ATA->var                            = (volatile uint32 *)(*(ATA->PtrVarTab));
   ATA->NumInc                         = 5;
   ATA->inc                            = (volatile uint32 *)(*(ATA->PtrVarTab) + (4*24));
   ATA->BDTableBase                    = &(ATA->var[0]);
   ATA->IncrBytes                      = (volatile sint16 *)&(ATA->inc[0])+1;
   ATA->BDTableLast                    = &(ATA->var[1]);
   ATA->IncrDst                        = (volatile sint16 *)&(ATA->inc[1])+1;
   ATA->Bytes                          = &(ATA->var[2]);
   ATA->IncrSrc                        = (volatile sint16 *)&(ATA->inc[2])+1;

   CRC16_DP_0->TaskNum                 = 6;
   CRC16_DP_0->PtrStartTDT             = (volatile uint32 *)(taskBar + 0x00c0UL);
   CRC16_DP_0->PtrEndTDT               = (volatile uint32 *)(taskBar + 0x00c4UL);
   CRC16_DP_0->PtrVarTab               = (volatile uint32 *)(taskBar + 0x00c8UL);
   CRC16_DP_0->PtrFDT                  = (volatile uint32 *)(taskBar + 0x00ccUL);
   CRC16_DP_0->PtrCSave                = (volatile uint32 *)(taskBar + 0x00d8UL);
   CRC16_DP_0->TaskPragma              = (volatile uint8  *)&(CRC16_DP_0->PtrFDT)+3;
   CRC16_DP_0->NumDRD                  = 9;
   CRC16_DP_0->DRD[0]                  = (volatile uint32 *)(*(CRC16_DP_0->PtrStartTDT) + 0x0004UL);
   CRC16_DP_0->DRD[1]                  = (volatile uint32 *)(*(CRC16_DP_0->PtrStartTDT) + 0x0008UL);
   CRC16_DP_0->DRD[2]                  = (volatile uint32 *)(*(CRC16_DP_0->PtrStartTDT) + 0x0014UL);
   CRC16_DP_0->DRD[3]                  = (volatile uint32 *)(*(CRC16_DP_0->PtrStartTDT) + 0x0018UL);
   CRC16_DP_0->DRD[4]                  = (volatile uint32 *)(*(CRC16_DP_0->PtrStartTDT) + 0x0024UL);
   CRC16_DP_0->DRD[5]                  = (volatile uint32 *)(*(CRC16_DP_0->PtrStartTDT) + 0x0028UL);
   CRC16_DP_0->DRD[6]                  = (volatile uint32 *)(*(CRC16_DP_0->PtrStartTDT) + 0x0034UL);
   CRC16_DP_0->DRD[7]                  = (volatile uint32 *)(*(CRC16_DP_0->PtrStartTDT) + 0x0038UL);
   CRC16_DP_0->DRD[8]                  = (volatile uint32 *)(*(CRC16_DP_0->PtrStartTDT) + 0x003cUL);
   CRC16_DP_0->NumVar                  = 10;
   CRC16_DP_0->var                     = (volatile uint32 *)(*(CRC16_DP_0->PtrVarTab));
   CRC16_DP_0->NumInc                  = 7;
   CRC16_DP_0->inc                     = (volatile uint32 *)(*(CRC16_DP_0->PtrVarTab) + (4*24));
   CRC16_DP_0->Bytes                   = &(CRC16_DP_0->var[0]);
   CRC16_DP_0->IncrBytes               = (volatile sint16 *)&(CRC16_DP_0->inc[0])+1;
   CRC16_DP_0->IterExtra               = &(CRC16_DP_0->var[1]);
   CRC16_DP_0->IncrDst                 = (volatile sint16 *)&(CRC16_DP_0->inc[1])+1;
   CRC16_DP_0->IncrDstMA               = (volatile sint16 *)&(CRC16_DP_0->inc[2])+1;
   CRC16_DP_0->IncrSrc                 = (volatile sint16 *)&(CRC16_DP_0->inc[3])+1;
   CRC16_DP_0->StartAddrDst            = &(CRC16_DP_0->var[4]);
   CRC16_DP_0->IncrSrcMA               = (volatile sint16 *)&(CRC16_DP_0->inc[4])+1;
   CRC16_DP_0->StartAddrSrc            = &(CRC16_DP_0->var[5]);

   CRC16_DP_1->TaskNum                 = 7;
   CRC16_DP_1->PtrStartTDT             = (volatile uint32 *)(taskBar + 0x00e0UL);
   CRC16_DP_1->PtrEndTDT               = (volatile uint32 *)(taskBar + 0x00e4UL);
   CRC16_DP_1->PtrVarTab               = (volatile uint32 *)(taskBar + 0x00e8UL);
   CRC16_DP_1->PtrFDT                  = (volatile uint32 *)(taskBar + 0x00ecUL);
   CRC16_DP_1->PtrCSave                = (volatile uint32 *)(taskBar + 0x00f8UL);
   CRC16_DP_1->TaskPragma              = (volatile uint8  *)&(CRC16_DP_1->PtrFDT)+3;
   CRC16_DP_1->NumDRD                  = 9;
   CRC16_DP_1->DRD[0]                  = (volatile uint32 *)(*(CRC16_DP_1->PtrStartTDT) + 0x0004UL);
   CRC16_DP_1->DRD[1]                  = (volatile uint32 *)(*(CRC16_DP_1->PtrStartTDT) + 0x0008UL);
   CRC16_DP_1->DRD[2]                  = (volatile uint32 *)(*(CRC16_DP_1->PtrStartTDT) + 0x0014UL);
   CRC16_DP_1->DRD[3]                  = (volatile uint32 *)(*(CRC16_DP_1->PtrStartTDT) + 0x0018UL);
   CRC16_DP_1->DRD[4]                  = (volatile uint32 *)(*(CRC16_DP_1->PtrStartTDT) + 0x0024UL);
   CRC16_DP_1->DRD[5]                  = (volatile uint32 *)(*(CRC16_DP_1->PtrStartTDT) + 0x0028UL);
   CRC16_DP_1->DRD[6]                  = (volatile uint32 *)(*(CRC16_DP_1->PtrStartTDT) + 0x0034UL);
   CRC16_DP_1->DRD[7]                  = (volatile uint32 *)(*(CRC16_DP_1->PtrStartTDT) + 0x0038UL);
   CRC16_DP_1->DRD[8]                  = (volatile uint32 *)(*(CRC16_DP_1->PtrStartTDT) + 0x003cUL);
   CRC16_DP_1->NumVar                  = 10;
   CRC16_DP_1->var                     = (volatile uint32 *)(*(CRC16_DP_1->PtrVarTab));
   CRC16_DP_1->NumInc                  = 7;
   CRC16_DP_1->inc                     = (volatile uint32 *)(*(CRC16_DP_1->PtrVarTab) + (4*24));
   CRC16_DP_1->Bytes                   = &(CRC16_DP_1->var[0]);
   CRC16_DP_1->IncrBytes               = (volatile sint16 *)&(CRC16_DP_1->inc[0])+1;
   CRC16_DP_1->IterExtra               = &(CRC16_DP_1->var[1]);
   CRC16_DP_1->IncrDst                 = (volatile sint16 *)&(CRC16_DP_1->inc[1])+1;
   CRC16_DP_1->IncrDstMA               = (volatile sint16 *)&(CRC16_DP_1->inc[2])+1;
   CRC16_DP_1->IncrSrc                 = (volatile sint16 *)&(CRC16_DP_1->inc[3])+1;
   CRC16_DP_1->StartAddrDst            = &(CRC16_DP_1->var[4]);
   CRC16_DP_1->IncrSrcMA               = (volatile sint16 *)&(CRC16_DP_1->inc[4])+1;
   CRC16_DP_1->StartAddrSrc            = &(CRC16_DP_1->var[5]);

   GEN_DP_0->TaskNum                   = 8;
   GEN_DP_0->PtrStartTDT               = (volatile uint32 *)(taskBar + 0x0100UL);
   GEN_DP_0->PtrEndTDT                 = (volatile uint32 *)(taskBar + 0x0104UL);
   GEN_DP_0->PtrVarTab                 = (volatile uint32 *)(taskBar + 0x0108UL);
   GEN_DP_0->PtrFDT                    = (volatile uint32 *)(taskBar + 0x010cUL);
   GEN_DP_0->PtrCSave                  = (volatile uint32 *)(taskBar + 0x0118UL);
   GEN_DP_0->TaskPragma                = (volatile uint8  *)&(GEN_DP_0->PtrFDT)+3;
   GEN_DP_0->NumDRD                    = 4;
   GEN_DP_0->DRD[0]                    = (volatile uint32 *)(*(GEN_DP_0->PtrStartTDT) + 0x000cUL);
   GEN_DP_0->DRD[1]                    = (volatile uint32 *)(*(GEN_DP_0->PtrStartTDT) + 0x0018UL);
   GEN_DP_0->DRD[2]                    = (volatile uint32 *)(*(GEN_DP_0->PtrStartTDT) + 0x0024UL);
   GEN_DP_0->DRD[3]                    = (volatile uint32 *)(*(GEN_DP_0->PtrStartTDT) + 0x0028UL);
   GEN_DP_0->NumVar                    = 9;
   GEN_DP_0->var                       = (volatile uint32 *)(*(GEN_DP_0->PtrVarTab));
   GEN_DP_0->NumInc                    = 7;
   GEN_DP_0->inc                       = (volatile uint32 *)(*(GEN_DP_0->PtrVarTab) + (4*24));
   GEN_DP_0->Bytes                     = &(GEN_DP_0->var[0]);
   GEN_DP_0->IncrBytes                 = (volatile sint16 *)&(GEN_DP_0->inc[0])+1;
   GEN_DP_0->IterExtra                 = &(GEN_DP_0->var[1]);
   GEN_DP_0->IncrDst                   = (volatile sint16 *)&(GEN_DP_0->inc[1])+1;
   GEN_DP_0->IncrDstMA                 = (volatile sint16 *)&(GEN_DP_0->inc[2])+1;
   GEN_DP_0->IncrSrc                   = (volatile sint16 *)&(GEN_DP_0->inc[3])+1;
   GEN_DP_0->StartAddrDst              = &(GEN_DP_0->var[4]);
   GEN_DP_0->IncrSrcMA                 = (volatile sint16 *)&(GEN_DP_0->inc[4])+1;
   GEN_DP_0->StartAddrSrc              = &(GEN_DP_0->var[5]);

   GEN_DP_1->TaskNum                   = 9;
   GEN_DP_1->PtrStartTDT               = (volatile uint32 *)(taskBar + 0x0120UL);
   GEN_DP_1->PtrEndTDT                 = (volatile uint32 *)(taskBar + 0x0124UL);
   GEN_DP_1->PtrVarTab                 = (volatile uint32 *)(taskBar + 0x0128UL);
   GEN_DP_1->PtrFDT                    = (volatile uint32 *)(taskBar + 0x012cUL);
   GEN_DP_1->PtrCSave                  = (volatile uint32 *)(taskBar + 0x0138UL);
   GEN_DP_1->TaskPragma                = (volatile uint8  *)&(GEN_DP_1->PtrFDT)+3;
   GEN_DP_1->NumDRD                    = 4;
   GEN_DP_1->DRD[0]                    = (volatile uint32 *)(*(GEN_DP_1->PtrStartTDT) + 0x000cUL);
   GEN_DP_1->DRD[1]                    = (volatile uint32 *)(*(GEN_DP_1->PtrStartTDT) + 0x0018UL);
   GEN_DP_1->DRD[2]                    = (volatile uint32 *)(*(GEN_DP_1->PtrStartTDT) + 0x0024UL);
   GEN_DP_1->DRD[3]                    = (volatile uint32 *)(*(GEN_DP_1->PtrStartTDT) + 0x0028UL);
   GEN_DP_1->NumVar                    = 9;
   GEN_DP_1->var                       = (volatile uint32 *)(*(GEN_DP_1->PtrVarTab));
   GEN_DP_1->NumInc                    = 7;
   GEN_DP_1->inc                       = (volatile uint32 *)(*(GEN_DP_1->PtrVarTab) + (4*24));
   GEN_DP_1->Bytes                     = &(GEN_DP_1->var[0]);
   GEN_DP_1->IncrBytes                 = (volatile sint16 *)&(GEN_DP_1->inc[0])+1;
   GEN_DP_1->IterExtra                 = &(GEN_DP_1->var[1]);
   GEN_DP_1->IncrDst                   = (volatile sint16 *)&(GEN_DP_1->inc[1])+1;
   GEN_DP_1->IncrDstMA                 = (volatile sint16 *)&(GEN_DP_1->inc[2])+1;
   GEN_DP_1->IncrSrc                   = (volatile sint16 *)&(GEN_DP_1->inc[3])+1;
   GEN_DP_1->StartAddrDst              = &(GEN_DP_1->var[4]);
   GEN_DP_1->IncrSrcMA                 = (volatile sint16 *)&(GEN_DP_1->inc[4])+1;
   GEN_DP_1->StartAddrSrc              = &(GEN_DP_1->var[5]);

   GEN_DP_2->TaskNum                   = 10;
   GEN_DP_2->PtrStartTDT               = (volatile uint32 *)(taskBar + 0x0140UL);
   GEN_DP_2->PtrEndTDT                 = (volatile uint32 *)(taskBar + 0x0144UL);
   GEN_DP_2->PtrVarTab                 = (volatile uint32 *)(taskBar + 0x0148UL);
   GEN_DP_2->PtrFDT                    = (volatile uint32 *)(taskBar + 0x014cUL);
   GEN_DP_2->PtrCSave                  = (volatile uint32 *)(taskBar + 0x0158UL);
   GEN_DP_2->TaskPragma                = (volatile uint8  *)&(GEN_DP_2->PtrFDT)+3;
   GEN_DP_2->NumDRD                    = 4;
   GEN_DP_2->DRD[0]                    = (volatile uint32 *)(*(GEN_DP_2->PtrStartTDT) + 0x000cUL);
   GEN_DP_2->DRD[1]                    = (volatile uint32 *)(*(GEN_DP_2->PtrStartTDT) + 0x0018UL);
   GEN_DP_2->DRD[2]                    = (volatile uint32 *)(*(GEN_DP_2->PtrStartTDT) + 0x0024UL);
   GEN_DP_2->DRD[3]                    = (volatile uint32 *)(*(GEN_DP_2->PtrStartTDT) + 0x0028UL);
   GEN_DP_2->NumVar                    = 9;
   GEN_DP_2->var                       = (volatile uint32 *)(*(GEN_DP_2->PtrVarTab));
   GEN_DP_2->NumInc                    = 7;
   GEN_DP_2->inc                       = (volatile uint32 *)(*(GEN_DP_2->PtrVarTab) + (4*24));
   GEN_DP_2->Bytes                     = &(GEN_DP_2->var[0]);
   GEN_DP_2->IncrBytes                 = (volatile sint16 *)&(GEN_DP_2->inc[0])+1;
   GEN_DP_2->IterExtra                 = &(GEN_DP_2->var[1]);
   GEN_DP_2->IncrDst                   = (volatile sint16 *)&(GEN_DP_2->inc[1])+1;
   GEN_DP_2->IncrDstMA                 = (volatile sint16 *)&(GEN_DP_2->inc[2])+1;
   GEN_DP_2->IncrSrc                   = (volatile sint16 *)&(GEN_DP_2->inc[3])+1;
   GEN_DP_2->StartAddrDst              = &(GEN_DP_2->var[4]);
   GEN_DP_2->IncrSrcMA                 = (volatile sint16 *)&(GEN_DP_2->inc[4])+1;
   GEN_DP_2->StartAddrSrc              = &(GEN_DP_2->var[5]);

   GEN_DP_3->TaskNum                   = 11;
   GEN_DP_3->PtrStartTDT               = (volatile uint32 *)(taskBar + 0x0160UL);
   GEN_DP_3->PtrEndTDT                 = (volatile uint32 *)(taskBar + 0x0164UL);
   GEN_DP_3->PtrVarTab                 = (volatile uint32 *)(taskBar + 0x0168UL);
   GEN_DP_3->PtrFDT                    = (volatile uint32 *)(taskBar + 0x016cUL);
   GEN_DP_3->PtrCSave                  = (volatile uint32 *)(taskBar + 0x0178UL);
   GEN_DP_3->TaskPragma                = (volatile uint8  *)&(GEN_DP_3->PtrFDT)+3;
   GEN_DP_3->NumDRD                    = 4;
   GEN_DP_3->DRD[0]                    = (volatile uint32 *)(*(GEN_DP_3->PtrStartTDT) + 0x000cUL);
   GEN_DP_3->DRD[1]                    = (volatile uint32 *)(*(GEN_DP_3->PtrStartTDT) + 0x0018UL);
   GEN_DP_3->DRD[2]                    = (volatile uint32 *)(*(GEN_DP_3->PtrStartTDT) + 0x0024UL);
   GEN_DP_3->DRD[3]                    = (volatile uint32 *)(*(GEN_DP_3->PtrStartTDT) + 0x0028UL);
   GEN_DP_3->NumVar                    = 9;
   GEN_DP_3->var                       = (volatile uint32 *)(*(GEN_DP_3->PtrVarTab));
   GEN_DP_3->NumInc                    = 7;
   GEN_DP_3->inc                       = (volatile uint32 *)(*(GEN_DP_3->PtrVarTab) + (4*24));
   GEN_DP_3->Bytes                     = &(GEN_DP_3->var[0]);
   GEN_DP_3->IncrBytes                 = (volatile sint16 *)&(GEN_DP_3->inc[0])+1;
   GEN_DP_3->IterExtra                 = &(GEN_DP_3->var[1]);
   GEN_DP_3->IncrDst                   = (volatile sint16 *)&(GEN_DP_3->inc[1])+1;
   GEN_DP_3->IncrDstMA                 = (volatile sint16 *)&(GEN_DP_3->inc[2])+1;
   GEN_DP_3->IncrSrc                   = (volatile sint16 *)&(GEN_DP_3->inc[3])+1;
   GEN_DP_3->StartAddrDst              = &(GEN_DP_3->var[4]);
   GEN_DP_3->IncrSrcMA                 = (volatile sint16 *)&(GEN_DP_3->inc[4])+1;
   GEN_DP_3->StartAddrSrc              = &(GEN_DP_3->var[5]);

   GEN_TX_BD->TaskNum                  = 12;
   GEN_TX_BD->PtrStartTDT              = (volatile uint32 *)(taskBar + 0x0180UL);
   GEN_TX_BD->PtrEndTDT                = (volatile uint32 *)(taskBar + 0x0184UL);
   GEN_TX_BD->PtrVarTab                = (volatile uint32 *)(taskBar + 0x0188UL);
   GEN_TX_BD->PtrFDT                   = (volatile uint32 *)(taskBar + 0x018cUL);
   GEN_TX_BD->PtrCSave                 = (volatile uint32 *)(taskBar + 0x0198UL);
   GEN_TX_BD->TaskPragma               = (volatile uint8  *)&(GEN_TX_BD->PtrFDT)+3;
   GEN_TX_BD->NumDRD                   = 4;
   GEN_TX_BD->DRD[0]                   = (volatile uint32 *)(*(GEN_TX_BD->PtrStartTDT) + 0x0008UL);
   GEN_TX_BD->DRD[1]                   = (volatile uint32 *)(*(GEN_TX_BD->PtrStartTDT) + 0x0014UL);
   GEN_TX_BD->DRD[2]                   = (volatile uint32 *)(*(GEN_TX_BD->PtrStartTDT) + 0x001cUL);
   GEN_TX_BD->DRD[3]                   = (volatile uint32 *)(*(GEN_TX_BD->PtrStartTDT) + 0x0020UL);
   GEN_TX_BD->NumVar                   = 8;
   GEN_TX_BD->var                      = (volatile uint32 *)(*(GEN_TX_BD->PtrVarTab));
   GEN_TX_BD->NumInc                   = 6;
   GEN_TX_BD->inc                      = (volatile uint32 *)(*(GEN_TX_BD->PtrVarTab) + (4*24));
   GEN_TX_BD->AddrDstFIFO              = &(GEN_TX_BD->var[0]);
   GEN_TX_BD->IncrBytes                = (volatile sint16 *)&(GEN_TX_BD->inc[0])+1;
   GEN_TX_BD->BDTableBase              = &(GEN_TX_BD->var[1]);
   GEN_TX_BD->IncrSrc                  = (volatile sint16 *)&(GEN_TX_BD->inc[1])+1;
   GEN_TX_BD->BDTableLast              = &(GEN_TX_BD->var[2]);
   GEN_TX_BD->IncrSrcMA                = (volatile sint16 *)&(GEN_TX_BD->inc[2])+1;
   GEN_TX_BD->Bytes                    = &(GEN_TX_BD->var[3]);

   GEN_RX_BD->TaskNum                  = 13;
   GEN_RX_BD->PtrStartTDT              = (volatile uint32 *)(taskBar + 0x01a0UL);
   GEN_RX_BD->PtrEndTDT                = (volatile uint32 *)(taskBar + 0x01a4UL);
   GEN_RX_BD->PtrVarTab                = (volatile uint32 *)(taskBar + 0x01a8UL);
   GEN_RX_BD->PtrFDT                   = (volatile uint32 *)(taskBar + 0x01acUL);
   GEN_RX_BD->PtrCSave                 = (volatile uint32 *)(taskBar + 0x01b8UL);
   GEN_RX_BD->TaskPragma               = (volatile uint8  *)&(GEN_RX_BD->PtrFDT)+3;
   GEN_RX_BD->NumDRD                   = 4;
   GEN_RX_BD->DRD[0]                   = (volatile uint32 *)(*(GEN_RX_BD->PtrStartTDT) + 0x0008UL);
   GEN_RX_BD->DRD[1]                   = (volatile uint32 *)(*(GEN_RX_BD->PtrStartTDT) + 0x0014UL);
   GEN_RX_BD->DRD[2]                   = (volatile uint32 *)(*(GEN_RX_BD->PtrStartTDT) + 0x0018UL);
   GEN_RX_BD->DRD[3]                   = (volatile uint32 *)(*(GEN_RX_BD->PtrStartTDT) + 0x001cUL);
   GEN_RX_BD->NumVar                   = 8;
   GEN_RX_BD->var                      = (volatile uint32 *)(*(GEN_RX_BD->PtrVarTab));
   GEN_RX_BD->NumInc                   = 4;
   GEN_RX_BD->inc                      = (volatile uint32 *)(*(GEN_RX_BD->PtrVarTab) + (4*24));
   GEN_RX_BD->AddrSrcFIFO              = &(GEN_RX_BD->var[0]);
   GEN_RX_BD->IncrBytes                = (volatile sint16 *)&(GEN_RX_BD->inc[0])+1;
   GEN_RX_BD->BDTableBase              = &(GEN_RX_BD->var[1]);
   GEN_RX_BD->IncrDst                  = (volatile sint16 *)&(GEN_RX_BD->inc[1])+1;
   GEN_RX_BD->BDTableLast              = &(GEN_RX_BD->var[2]);
   GEN_RX_BD->Bytes                    = &(GEN_RX_BD->var[3]);

   GEN_DP_BD_0->TaskNum                = 14;
   GEN_DP_BD_0->PtrStartTDT            = (volatile uint32 *)(taskBar + 0x01c0UL);
   GEN_DP_BD_0->PtrEndTDT              = (volatile uint32 *)(taskBar + 0x01c4UL);
   GEN_DP_BD_0->PtrVarTab              = (volatile uint32 *)(taskBar + 0x01c8UL);
   GEN_DP_BD_0->PtrFDT                 = (volatile uint32 *)(taskBar + 0x01ccUL);
   GEN_DP_BD_0->PtrCSave               = (volatile uint32 *)(taskBar + 0x01d8UL);
   GEN_DP_BD_0->TaskPragma             = (volatile uint8  *)&(GEN_DP_BD_0->PtrFDT)+3;
   GEN_DP_BD_0->NumDRD                 = 3;
   GEN_DP_BD_0->DRD[0]                 = (volatile uint32 *)(*(GEN_DP_BD_0->PtrStartTDT) + 0x0008UL);
   GEN_DP_BD_0->DRD[1]                 = (volatile uint32 *)(*(GEN_DP_BD_0->PtrStartTDT) + 0x0018UL);
   GEN_DP_BD_0->DRD[2]                 = (volatile uint32 *)(*(GEN_DP_BD_0->PtrStartTDT) + 0x001cUL);
   GEN_DP_BD_0->NumVar                 = 7;
   GEN_DP_BD_0->var                    = (volatile uint32 *)(*(GEN_DP_BD_0->PtrVarTab));
   GEN_DP_BD_0->NumInc                 = 5;
   GEN_DP_BD_0->inc                    = (volatile uint32 *)(*(GEN_DP_BD_0->PtrVarTab) + (4*24));
   GEN_DP_BD_0->BDTableBase            = &(GEN_DP_BD_0->var[0]);
   GEN_DP_BD_0->IncrBytes              = (volatile sint16 *)&(GEN_DP_BD_0->inc[0])+1;
   GEN_DP_BD_0->BDTableLast            = &(GEN_DP_BD_0->var[1]);
   GEN_DP_BD_0->IncrDst                = (volatile sint16 *)&(GEN_DP_BD_0->inc[1])+1;
   GEN_DP_BD_0->Bytes                  = &(GEN_DP_BD_0->var[2]);
   GEN_DP_BD_0->IncrSrc                = (volatile sint16 *)&(GEN_DP_BD_0->inc[2])+1;

   GEN_DP_BD_1->TaskNum                = 15;
   GEN_DP_BD_1->PtrStartTDT            = (volatile uint32 *)(taskBar + 0x01e0UL);
   GEN_DP_BD_1->PtrEndTDT              = (volatile uint32 *)(taskBar + 0x01e4UL);
   GEN_DP_BD_1->PtrVarTab              = (volatile uint32 *)(taskBar + 0x01e8UL);
   GEN_DP_BD_1->PtrFDT                 = (volatile uint32 *)(taskBar + 0x01ecUL);
   GEN_DP_BD_1->PtrCSave               = (volatile uint32 *)(taskBar + 0x01f8UL);
   GEN_DP_BD_1->TaskPragma             = (volatile uint8  *)&(GEN_DP_BD_1->PtrFDT)+3;
   GEN_DP_BD_1->NumDRD                 = 3;
   GEN_DP_BD_1->DRD[0]                 = (volatile uint32 *)(*(GEN_DP_BD_1->PtrStartTDT) + 0x0008UL);
   GEN_DP_BD_1->DRD[1]                 = (volatile uint32 *)(*(GEN_DP_BD_1->PtrStartTDT) + 0x0018UL);
   GEN_DP_BD_1->DRD[2]                 = (volatile uint32 *)(*(GEN_DP_BD_1->PtrStartTDT) + 0x001cUL);
   GEN_DP_BD_1->NumVar                 = 7;
   GEN_DP_BD_1->var                    = (volatile uint32 *)(*(GEN_DP_BD_1->PtrVarTab));
   GEN_DP_BD_1->NumInc                 = 5;
   GEN_DP_BD_1->inc                    = (volatile uint32 *)(*(GEN_DP_BD_1->PtrVarTab) + (4*24));
   GEN_DP_BD_1->BDTableBase            = &(GEN_DP_BD_1->var[0]);
   GEN_DP_BD_1->IncrBytes              = (volatile sint16 *)&(GEN_DP_BD_1->inc[0])+1;
   GEN_DP_BD_1->BDTableLast            = &(GEN_DP_BD_1->var[1]);
   GEN_DP_BD_1->IncrDst                = (volatile sint16 *)&(GEN_DP_BD_1->inc[1])+1;
   GEN_DP_BD_1->Bytes                  = &(GEN_DP_BD_1->var[2]);
   GEN_DP_BD_1->IncrSrc                = (volatile sint16 *)&(GEN_DP_BD_1->inc[2])+1;
}
