#ifndef __DMA_IMAGE_CAPI_H
#define __DMA_IMAGE_CAPI_H 1

#include "dma_image.h"

typedef enum {
   TASK_PCI_TX,
   TASK_PCI_RX,
   TASK_FEC_TX,
   TASK_FEC_RX,
   TASK_LPC,
   TASK_ATA,
   TASK_CRC16_DP_0,
   TASK_CRC16_DP_1,
   TASK_GEN_DP_0,
   TASK_GEN_DP_1,
   TASK_GEN_DP_2,
   TASK_GEN_DP_3,
   TASK_GEN_TX_BD,
   TASK_GEN_RX_BD,
   TASK_GEN_DP_BD_0,
   TASK_GEN_DP_BD_1
} TaskName_t;

TaskId TaskSetup_TASK_PCI_TX    (pci_tx_api          *TaskAPI,
                                 TaskSetupParamSet_t *TaskSetupParams);
TaskId TaskSetup_TASK_PCI_RX    (pci_rx_api          *TaskAPI,
                                 TaskSetupParamSet_t *TaskSetupParams);
TaskId TaskSetup_TASK_FEC_TX    (fec_tx_bd_api       *TaskAPI,
                                 TaskSetupParamSet_t *TaskSetupParams);
TaskId TaskSetup_TASK_FEC_RX    (fec_rx_bd_api       *TaskAPI,
                                 TaskSetupParamSet_t *TaskSetupParams);
TaskId TaskSetup_TASK_LPC       (gen_dp_api          *TaskAPI,
                                 TaskSetupParamSet_t *TaskSetupParams);
TaskId TaskSetup_TASK_ATA       (gen_dp_bd_api       *TaskAPI,
                                 TaskSetupParamSet_t *TaskSetupParams);
TaskId TaskSetup_TASK_CRC16_DP_0(crc16_dp_api        *TaskAPI,
                                 TaskSetupParamSet_t *TaskSetupParams);
TaskId TaskSetup_TASK_CRC16_DP_1(crc16_dp_api        *TaskAPI,
                                 TaskSetupParamSet_t *TaskSetupParams);
TaskId TaskSetup_TASK_GEN_DP_0  (gen_dp_api          *TaskAPI,
                                 TaskSetupParamSet_t *TaskSetupParams);
TaskId TaskSetup_TASK_GEN_DP_1  (gen_dp_api          *TaskAPI,
                                 TaskSetupParamSet_t *TaskSetupParams);
TaskId TaskSetup_TASK_GEN_DP_2  (gen_dp_api          *TaskAPI,
                                 TaskSetupParamSet_t *TaskSetupParams);
TaskId TaskSetup_TASK_GEN_DP_3  (gen_dp_api          *TaskAPI,
                                 TaskSetupParamSet_t *TaskSetupParams);
TaskId TaskSetup_TASK_GEN_TX_BD (gen_tx_bd_api       *TaskAPI,
                                 TaskSetupParamSet_t *TaskSetupParams);
TaskId TaskSetup_TASK_GEN_RX_BD (gen_rx_bd_api       *TaskAPI,
                                 TaskSetupParamSet_t *TaskSetupParams);
TaskId TaskSetup_TASK_GEN_DP_BD_0(gen_dp_bd_api       *TaskAPI,
                                 TaskSetupParamSet_t *TaskSetupParams);
TaskId TaskSetup_TASK_GEN_DP_BD_1(gen_dp_bd_api       *TaskAPI,
                                 TaskSetupParamSet_t *TaskSetupParams);

#endif

