/* Header file for variable definitions */

#ifndef __DMA_IMAGE_H
#define __DMA_IMAGE_H 1

#include "ppctypes.h"

void init_dma_image(uint8 *taskBar);

/* MBAR_TASK_TABLE is the first address of task table */
#ifndef MBAR_TASK_TABLE                    
#define MBAR_TASK_TABLE                     0xf0008000UL
#endif

/* MBAR_DMA_FREE is the first free address after task table */
#define MBAR_DMA_FREE                       MBAR_TASK_TABLE + 0x00001300UL

/* TASK_BAR is the first address of the Entry table */
#define TASK_BAR                            MBAR_TASK_TABLE + 0x00000000UL
#define TASK_BAR_OFFSET                     0x00000000UL

typedef struct task_info0 {
   volatile uint32  TaskNum;
   volatile uint32 *PtrStartTDT;
   volatile uint32 *PtrEndTDT;
   volatile uint32 *PtrVarTab;
   volatile uint32 *PtrFDT;
   volatile uint32 *PtrCSave;
   volatile uint32  NumDRD;
   volatile uint32 *DRD[7];
   volatile uint32  NumVar;
   volatile uint32 *var;
   volatile uint32  NumInc;
   volatile uint32 *inc;
   volatile uint8  *TaskPragma;
   volatile uint32 *AddrDstFIFO;
   volatile sint16 *IncrBytes;
   volatile uint32 *AddrPktSizeReg;
   volatile sint16 *IncrSrc;
   volatile uint32 *AddrSCStatusReg;
   volatile uint32 *Bytes;
   volatile uint32 *IterExtra;
   volatile uint32 *StartAddrSrc;
} pci_tx_api;
extern pci_tx_api *PCI_TX;

typedef struct task_info1 {
   volatile uint32  TaskNum;
   volatile uint32 *PtrStartTDT;
   volatile uint32 *PtrEndTDT;
   volatile uint32 *PtrVarTab;
   volatile uint32 *PtrFDT;
   volatile uint32 *PtrCSave;
   volatile uint32  NumDRD;
   volatile uint32 *DRD[5];
   volatile uint32  NumVar;
   volatile uint32 *var;
   volatile uint32  NumInc;
   volatile uint32 *inc;
   volatile uint8  *TaskPragma;
   volatile uint32 *AddrPktSizeReg;
   volatile sint16 *IncrBytes;
   volatile uint32 *AddrSrcFIFO;
   volatile sint16 *IncrDst;
   volatile uint32 *Bytes;
   volatile uint32 *IterExtra;
   volatile uint32 *StartAddrDst;
} pci_rx_api;
extern pci_rx_api *PCI_RX;

typedef struct task_info2 {
   volatile uint32  TaskNum;
   volatile uint32 *PtrStartTDT;
   volatile uint32 *PtrEndTDT;
   volatile uint32 *PtrVarTab;
   volatile uint32 *PtrFDT;
   volatile uint32 *PtrCSave;
   volatile uint32  NumDRD;
   volatile uint32 *DRD[11];
   volatile uint32  NumVar;
   volatile uint32 *var;
   volatile uint32  NumInc;
   volatile uint32 *inc;
   volatile uint8  *TaskPragma;
   volatile uint32 *AddrDRD;
   volatile sint16 *IncrBytes;
   volatile uint32 *AddrDstFIFO;
   volatile sint16 *IncrSrc;
   volatile uint32 *BDTableBase;
   volatile sint16 *IncrSrcMA;
   volatile uint32 *BDTableLast;
   volatile uint32 *Bytes;
} fec_tx_bd_api;
extern fec_tx_bd_api *FEC_TX;

typedef struct task_info3 {
   volatile uint32  TaskNum;
   volatile uint32 *PtrStartTDT;
   volatile uint32 *PtrEndTDT;
   volatile uint32 *PtrVarTab;
   volatile uint32 *PtrFDT;
   volatile uint32 *PtrCSave;
   volatile uint32  NumDRD;
   volatile uint32 *DRD[3];
   volatile uint32  NumVar;
   volatile uint32 *var;
   volatile uint32  NumInc;
   volatile uint32 *inc;
   volatile uint8  *TaskPragma;
   volatile uint32 *AddrSrcFIFO;
   volatile sint16 *IncrBytes;
   volatile uint32 *BDTableBase;
   volatile sint16 *IncrDst;
   volatile uint32 *BDTableLast;
   volatile uint32 *Bytes;
} fec_rx_bd_api;
extern fec_rx_bd_api *FEC_RX;

typedef struct task_info4 {
   volatile uint32  TaskNum;
   volatile uint32 *PtrStartTDT;
   volatile uint32 *PtrEndTDT;
   volatile uint32 *PtrVarTab;
   volatile uint32 *PtrFDT;
   volatile uint32 *PtrCSave;
   volatile uint32  NumDRD;
   volatile uint32 *DRD[4];
   volatile uint32  NumVar;
   volatile uint32 *var;
   volatile uint32  NumInc;
   volatile uint32 *inc;
   volatile uint8  *TaskPragma;
   volatile uint32 *Bytes;
   volatile sint16 *IncrBytes;
   volatile uint32 *IterExtra;
   volatile sint16 *IncrDst;
   volatile sint16 *IncrDstMA;
   volatile sint16 *IncrSrc;
   volatile uint32 *StartAddrDst;
   volatile sint16 *IncrSrcMA;
   volatile uint32 *StartAddrSrc;
} gen_dp_api;
extern gen_dp_api *LPC;

typedef struct task_info5 {
   volatile uint32  TaskNum;
   volatile uint32 *PtrStartTDT;
   volatile uint32 *PtrEndTDT;
   volatile uint32 *PtrVarTab;
   volatile uint32 *PtrFDT;
   volatile uint32 *PtrCSave;
   volatile uint32  NumDRD;
   volatile uint32 *DRD[3];
   volatile uint32  NumVar;
   volatile uint32 *var;
   volatile uint32  NumInc;
   volatile uint32 *inc;
   volatile uint8  *TaskPragma;
   volatile uint32 *BDTableBase;
   volatile sint16 *IncrBytes;
   volatile uint32 *BDTableLast;
   volatile sint16 *IncrDst;
   volatile uint32 *Bytes;
   volatile sint16 *IncrSrc;
} gen_dp_bd_api;
extern gen_dp_bd_api *ATA;

typedef struct task_info6 {
   volatile uint32  TaskNum;
   volatile uint32 *PtrStartTDT;
   volatile uint32 *PtrEndTDT;
   volatile uint32 *PtrVarTab;
   volatile uint32 *PtrFDT;
   volatile uint32 *PtrCSave;
   volatile uint32  NumDRD;
   volatile uint32 *DRD[9];
   volatile uint32  NumVar;
   volatile uint32 *var;
   volatile uint32  NumInc;
   volatile uint32 *inc;
   volatile uint8  *TaskPragma;
   volatile uint32 *Bytes;
   volatile sint16 *IncrBytes;
   volatile uint32 *IterExtra;
   volatile sint16 *IncrDst;
   volatile sint16 *IncrDstMA;
   volatile sint16 *IncrSrc;
   volatile uint32 *StartAddrDst;
   volatile sint16 *IncrSrcMA;
   volatile uint32 *StartAddrSrc;
} crc16_dp_api;
extern crc16_dp_api *CRC16_DP_0;

extern crc16_dp_api *CRC16_DP_1;

extern gen_dp_api *GEN_DP_0;

extern gen_dp_api *GEN_DP_1;

extern gen_dp_api *GEN_DP_2;

extern gen_dp_api *GEN_DP_3;

typedef struct task_info12 {
   volatile uint32  TaskNum;
   volatile uint32 *PtrStartTDT;
   volatile uint32 *PtrEndTDT;
   volatile uint32 *PtrVarTab;
   volatile uint32 *PtrFDT;
   volatile uint32 *PtrCSave;
   volatile uint32  NumDRD;
   volatile uint32 *DRD[4];
   volatile uint32  NumVar;
   volatile uint32 *var;
   volatile uint32  NumInc;
   volatile uint32 *inc;
   volatile uint8  *TaskPragma;
   volatile uint32 *AddrDstFIFO;
   volatile sint16 *IncrBytes;
   volatile uint32 *BDTableBase;
   volatile sint16 *IncrSrc;
   volatile uint32 *BDTableLast;
   volatile sint16 *IncrSrcMA;
   volatile uint32 *Bytes;
} gen_tx_bd_api;
extern gen_tx_bd_api *GEN_TX_BD;

typedef struct task_info13 {
   volatile uint32  TaskNum;
   volatile uint32 *PtrStartTDT;
   volatile uint32 *PtrEndTDT;
   volatile uint32 *PtrVarTab;
   volatile uint32 *PtrFDT;
   volatile uint32 *PtrCSave;
   volatile uint32  NumDRD;
   volatile uint32 *DRD[4];
   volatile uint32  NumVar;
   volatile uint32 *var;
   volatile uint32  NumInc;
   volatile uint32 *inc;
   volatile uint8  *TaskPragma;
   volatile uint32 *AddrSrcFIFO;
   volatile sint16 *IncrBytes;
   volatile uint32 *BDTableBase;
   volatile sint16 *IncrDst;
   volatile uint32 *BDTableLast;
   volatile uint32 *Bytes;
} gen_rx_bd_api;
extern gen_rx_bd_api *GEN_RX_BD;

extern gen_dp_bd_api *GEN_DP_BD_0;

extern gen_dp_bd_api *GEN_DP_BD_1;


#endif