
#include "bestcomm_api.h"
#include "tasksetup_bdtable.h"
#include "mgt5200.h"

#ifdef __MWERKS__
__declspec(section ".text") extern const uint32 taskTable;
__declspec(section ".text") extern const uint32 taskTableBytes;
__declspec(section ".text") extern const uint32 taskTableTasks;
__declspec(section ".text") extern const uint32 offsetEntry;
#else
extern const uint32 taskTable;
extern const uint32 taskTableBytes;
extern const uint32 taskTableTasks;
extern const uint32 offsetEntry;
#endif

TaskBDIdxTable_t TaskBDIdxTable[MAX_TASKS];
extern uint8 *MBarGlobal;
static uint8 *TaskTableFree = 0;

void TaskSetup_BDTable (volatile uint32 *BasePtr, volatile uint32 *LastPtr,
                        int TaskNum, uint32 NumBD, uint16 MaxBD,
                        uint8 NumPtr, ApiConfig_t ApiConfig, uint32 Status) 
{
   int i, j;
   uint32 *ptr;

   if (TaskTableFree == 0) {
       TaskTableFree = MBarGlobal + MBAR_SRAM + taskTableBytes;
   }
   if (TaskBDIdxTable[TaskNum].BDTablePtr == 0) {
       TaskBDIdxTable[TaskNum].BDTablePtr = TaskTableFree;
       TaskBDIdxTable[TaskNum].numBD      = (uint16)NumBD;
       TaskBDIdxTable[TaskNum].numPtr     = NumPtr;
       TaskBDIdxTable[TaskNum].apiConfig  = ApiConfig;

       *BasePtr = (uint32)TaskBDIdxTable[TaskNum].BDTablePtr;

       switch (NumPtr) {
          case 1:
             TaskTableFree += MaxBD*sizeof(TaskBD1_t);
             *LastPtr = (uint32)(*BasePtr + sizeof(TaskBD1_t) * (NumBD - 1));
             break;
          case 2:
             TaskTableFree += MaxBD*sizeof(TaskBD2_t);
             *LastPtr = (uint32)(*BasePtr + sizeof(TaskBD2_t) * (NumBD - 1));
             break;
          default:
             /* error */
             break;
       }
   }

   /*
    * Set the status bits. Clear the data pointers.
    */
   if (MaxBD > 0) {
      ptr = TaskBDIdxTable[TaskNum].BDTablePtr;
      for (i = 0; i < NumBD; i++) {
         *(ptr++) = Status;
         for (j = 0; j < NumPtr; j++) {
            *(ptr++) = 0x0;
         }
      }
   }
}
